/*	$OpenBSD: flex.skl,v 1.6 2001/01/05 18:26:23 millert Exp $	*/

/* A lexical scanner generated by flex */

/* Scanner skeleton version:
 * $Header: /cvs/src/usr.bin/lex/flex.skl,v 1.6 2001/01/05 18:26:23 millert Exp $
 */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 5

#include <stdio.h>
#include <errno.h>


/* cfront 1.2 defines "c_plusplus" instead of "__cplusplus" */
#ifdef c_plusplus
#ifndef __cplusplus
#define __cplusplus
#endif
#endif


#ifdef __cplusplus

#include <stdlib.h>
#include <unistd.h>

/* Use prototypes in function declarations. */
#define YY_USE_PROTOS

/* The "const" storage-class-modifier is valid. */
#define YY_USE_CONST

#else	/* ! __cplusplus */

#ifdef __STDC__

#define YY_USE_PROTOS
#define YY_USE_CONST

#endif	/* __STDC__ */
#endif	/* ! __cplusplus */

#ifdef __TURBOC__
 #pragma warn -rch
 #pragma warn -use
#include <io.h>
#include <stdlib.h>
#define YY_USE_CONST
#define YY_USE_PROTOS
#endif

#ifdef YY_USE_CONST
#define yyconst const
#else
#define yyconst
#endif


#ifdef YY_USE_PROTOS
#define YY_PROTO(proto) proto
#else
#define YY_PROTO(proto) ()
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN yy_start = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START ((yy_start - 1) / 2)
#define YYSTATE YY_START

/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE yyrestart( yyin )

#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#define YY_BUF_SIZE 16384

typedef struct yy_buffer_state *YY_BUFFER_STATE;

extern int yyleng;
extern FILE *yyin, *yyout;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

/* The funky do-while in the following #define is used to turn the definition
 * int a single C statement (which needs a semi-colon terminator).  This
 * avoids problems with code like:
 *
 * 	if ( condition_holds )
 *		yyless( 5 );
 *	else
 *		do_something_else();
 *
 * Prior to using the do-while the compiler would get upset at the
 * "else" because it interpreted the "if" statement as being all
 * done when it reached the ';' after the yyless() call.
 */

/* Return all but the first 'n' matched characters back to the input stream. */

#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
		*yy_cp = yy_hold_char; \
		YY_RESTORE_YY_MORE_OFFSET \
		yy_c_buf_p = yy_cp = yy_bp + n - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )

#define unput(c) yyunput( c, yytext_ptr )

/* The following is because we cannot portably get our hands on size_t
 * (without autoconf's help, which isn't available because we want
 * flex-generated scanners to compile on their own).
 */
typedef unsigned int yy_size_t;


struct yy_buffer_state
	{
	FILE *yy_input_file;

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	yy_size_t yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;
#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via yyrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2
	};

static YY_BUFFER_STATE yy_current_buffer = 0;

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 */
#define YY_CURRENT_BUFFER yy_current_buffer


/* yy_hold_char holds the character lost when yytext is formed. */
static char yy_hold_char;

static int yy_n_chars;		/* number of characters read into yy_ch_buf */


int yyleng;

/* Points to current character in buffer. */
static char *yy_c_buf_p = (char *) 0;
static int yy_init = 1;		/* whether we need to initialize */
static int yy_start = 0;	/* start state number */

/* Flag which is used to allow yywrap()'s to do buffer switches
 * instead of setting up a fresh yyin.  A bit of a hack ...
 */
static int yy_did_buffer_switch_on_eof;

void yyrestart YY_PROTO(( FILE *input_file ));

void yy_switch_to_buffer YY_PROTO(( YY_BUFFER_STATE new_buffer ));
void yy_load_buffer_state YY_PROTO(( void ));
YY_BUFFER_STATE yy_create_buffer YY_PROTO(( FILE *file, int size ));
void yy_delete_buffer YY_PROTO(( YY_BUFFER_STATE b ));
void yy_init_buffer YY_PROTO(( YY_BUFFER_STATE b, FILE *file ));
void yy_flush_buffer YY_PROTO(( YY_BUFFER_STATE b ));
#define YY_FLUSH_BUFFER yy_flush_buffer( yy_current_buffer )

YY_BUFFER_STATE yy_scan_buffer YY_PROTO(( char *base, yy_size_t size ));
YY_BUFFER_STATE yy_scan_string YY_PROTO(( yyconst char *yy_str ));
YY_BUFFER_STATE yy_scan_bytes YY_PROTO(( yyconst char *bytes, int len ));

static void *yy_flex_alloc YY_PROTO(( yy_size_t ));
static void *yy_flex_realloc YY_PROTO(( void *, yy_size_t ));
static void yy_flex_free YY_PROTO(( void * ));

#define yy_new_buffer yy_create_buffer

#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! yy_current_buffer ) \
		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE ); \
	yy_current_buffer->yy_is_interactive = is_interactive; \
	}

#define yy_set_bol(at_bol) \
	{ \
	if ( ! yy_current_buffer ) \
		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE ); \
	yy_current_buffer->yy_at_bol = at_bol; \
	}

#define YY_AT_BOL() (yy_current_buffer->yy_at_bol)


#define YY_USES_REJECT
typedef unsigned char YY_CHAR;
FILE *yyin = (FILE *) 0, *yyout = (FILE *) 0;
typedef int yy_state_type;
extern char *yytext;
#define yytext_ptr yytext

static yy_state_type yy_get_previous_state YY_PROTO(( void ));
static yy_state_type yy_try_NUL_trans YY_PROTO(( yy_state_type current_state ));
static int yy_get_next_buffer YY_PROTO(( void ));
static void yy_fatal_error YY_PROTO(( yyconst char msg[] ));

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	yytext_ptr = yy_bp; \
	yyleng = (int) (yy_cp - yy_bp); \
	yy_hold_char = *yy_cp; \
	*yy_cp = '\0'; \
	yy_c_buf_p = yy_cp;

#define YY_NUM_RULES 49
#define YY_END_OF_BUFFER 50
static yyconst short int yy_acclist[366] =
    {   0,
       50,   48,   49,    3,   48,   49,    2,    4,   49,    2,
        4,   48,   49,   35,   48,   49,   10,   48,   49,   48,
       49,   48,   49,   34,   48,   49,   48,   49,   48,   49,
       47,   48,   49,   48,   49,   48,   49,   48,   49,   45,
       48,   49,16428,   45,   48,   49,16428,   45,   48,   49,
    16428,   45,   48,   49,16428,   25,   48,   49,   48,   49,
    16428,   33,   48,   49,    6,   49,    7,   49,    6,    7,
       49,    6,   49,   24,   49,   12,   49,   12,   49,   11,
       49,   49,   48,   49,    3,   48,   49,    4,   49,    4,
       48,   49,   35,   48,   49,   10,   48,   49,   48,   49,

       48,   49,   34,   48,   49,   48,   49,   48,   49,   47,
       48,   49,   48,   49,   48,   49,   48,   49,   45,   48,
       49,16428,   45,   48,   49,16428,   45,   48,   49,16428,
       45,   48,   49,16428,   45,   48,   49,16428,   45,   48,
       49,16428,   45,   48,   49,16428,   45,   48,   49,16428,
       27,   45,   48,   49,16428,   28,   45,   48,   49,16428,
       25,   48,   49,   26,   48,   49,   48,   49,16428,   33,
       48,   49,   45,   48,   49,16428,   45,   48,   49,16428,
       45,   48,   49,16428,   45,   48,   49,16428,    2,    2,
        4,    4,    4,    2,    4,    2,    4,    4,   31,    2,

        9,    2,   34,   46,    5,   47,   29,   32,   30,   45,
    16428, 8236,   45,16428,   45,16428,   33,   45,16428,16428,
       33,    7,    8,   24,   12,   23,   13,   15,   23,   15,
       23,   16,   23,   17,   23,   18,   23,   19,   23,   20,
       23,   21,   23,   22,   23,   23,    4,   31,    9,   34,
       46,    5,   47,   29,   32,   30,   45,16428, 8236,   45,
    16428,   45,16428,   45,16428,   45,16428,   33,   45,16428,
       45,16428,   45,16428,16428,   33,   45,16428,   45,16428,
       45,16428,   45,16428,    2,    4,    4,    2,    9,    1,
        2,    2,   46,    2,   34,   45,16428,   35,   45,16428,

       13,   15,   15,   14,    1,   46,   34,   45,16428,   42,
     8236,   40, 8236,   35,   45,16428,   38, 8236,   45,16428,
       43, 8236,   41, 8236,   39, 8236,   45,16428,    4,    4,
        4,    4,    2,    4,    4,    4,    1,    2,    9,    2,
        1,    2, 8236,   13,   15,   14,    1,    9, 8236,   45,
    16428,   45,16428,    4,    4,    1,    2,    9,    2,   36,
     8236,   37, 8236, 8236, 8236
    } ;

static yyconst short int yy_accept[261] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    2,    4,    7,   10,   14,   17,   20,   22,   24,
       27,   29,   31,   34,   36,   38,   40,   44,   48,   52,
       56,   59,   62,   65,   67,   69,   72,   74,   76,   78,
       80,   82,   83,   85,   88,   90,   93,   96,   99,  101,
      103,  106,  108,  110,  113,  115,  117,  119,  123,  127,
      131,  135,  139,  143,  147,  151,  156,  161,  164,  167,
      170,  173,  177,  181,  185,  189,  189,  190,  191,  191,
      192,  193,  194,  196,  198,  199,  200,  200,  202,  203,
      203,  203,  204,  205,  206,  206,  207,  207,  208,  209,

      210,  210,  210,  212,  213,  215,  217,  220,  221,  222,
      223,  224,  225,  226,  227,  230,  232,  234,  236,  238,
      240,  242,  244,  246,  247,  247,  247,  248,  249,  249,
      250,  250,  250,  251,  252,  253,  253,  254,  254,  255,
      256,  257,  257,  257,  259,  260,  262,  264,  266,  268,
      271,  273,  275,  276,  277,  279,  281,  283,  285,  286,
      287,  288,  290,  290,  290,  292,  293,  293,  293,  293,
      294,  294,  295,  295,  295,  298,  301,  303,  304,  305,
      305,  305,  306,  306,  306,  306,  307,  307,  307,  307,
      310,  310,  312,  312,  314,  317,  317,  319,  321,  321,

      323,  323,  325,  325,  327,  329,  330,  331,  332,  333,
      335,  336,  337,  337,  340,  341,  341,  341,  343,  343,
      343,  343,  344,  346,  347,  347,  349,  349,  349,  349,
      349,  349,  350,  352,  354,  355,  356,  359,  359,  359,
      360,  360,  360,  360,  360,  360,  360,  360,  360,  360,
      362,  362,  364,  364,  364,  365,  365,  365,  366,  366
    } ;

static yyconst int yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    4,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    2,    5,    6,    7,    8,    1,    9,    6,   10,
       11,   12,   13,    1,   13,   14,   15,   16,   16,   16,
       16,   16,   16,   16,   16,   17,   17,    1,    1,   18,
       19,   20,    1,    1,   21,   22,   22,   23,   24,   25,
       26,   27,   28,   27,   29,   27,   27,   30,   31,   32,
       27,   33,   34,   35,   27,   27,   27,   36,   37,   27,
       38,   39,   40,    1,   41,    1,   42,   43,   22,   23,

       22,   44,   26,   27,   28,   27,   29,   27,   27,   45,
       31,   32,   27,   46,   34,   47,   27,   48,   27,   49,
       37,   27,    1,   50,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static yyconst int yy_meta[51] =
    {   0,
        1,    1,    2,    3,    1,    3,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    4,    4,    1,    1,    1,
        4,    4,    4,    4,    4,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    3,    1,
        1,    4,    4,    4,    1,    1,    1,    1,    1,    1
    } ;

static yyconst short int yy_base[282] =
    {   0,
        0,    0,   48,   50,   52,   60,   99,    0,  125,    0,
      913,   64,   66,  898,   72,   74,   80,   82,  174,  164,
      222,  152,  228,  243,  245,  251,  270,   49,  198,  291,
      149,  337,  385, 2204, 2204,  878,  862,    0, 2204,  867,
     2204,  420,  846,  840,  832,   84,  242,  724,  232,  469,
       87,   81,   49,  382,  248,  250,  314,  519,  362,  367,
      370,  364,  372,  380,  393,  381,  383,  718,  716,  569,
      383,  386,  400,  409,  411,  322, 2204,  324,    0,  614,
      619,  443,  564,  445,  669,  717,  719, 2204,  725,  733,
      783,  831,  833,  839,  848,  855,  870,  858,  872,  881,

      888,  891,  397,  897,  427,  873,  399,    0,  906, 2204,
     2204,    0, 2204, 2204,  217,  249, 2204, 2204, 2204, 2204,
     2204, 2204, 2204,    0,  514,    0,  447,  424,  326, 2204,
      920,  970,  327, 1013,  323,  444, 1017, 1019,  315,  252,
      249,  836,  413,  815,  233, 1015, 1020, 1021, 1012,  823,
     1024, 1016,    0,  229, 1051, 1053, 1054, 1034, 2204, 1099,
     1149, 2204, 1199,  908, 2204, 1072, 1249,    0, 1074, 1297,
     1300, 1312, 1323, 1372,  837,  874,  442,  714,    0, 1391,
      400, 2204, 1441,    0, 1077, 1369, 1081, 1491, 1540, 1018,
     1542,  219, 1545,  162, 1022, 1552,  158, 1277, 1555,  155,

     1565,  146, 1568,   73, 1513,  885, 1587,    0, 1577, 1635,
     1643,    0, 1691, 2204, 1693, 1701,    0, 2204,    0, 1751,
     1800, 1806, 1365, 2204, 1309, 2204, 1819,    0,    0, 1869,
     1918, 1571, 1919, 1920,    0,    0, 2204,    0, 1924, 1937,
     1965, 2014,    0,    0, 1948, 2033, 2082,    0, 1923,   65,
     2084,   63,    0, 2094, 1949,    0, 2104, 2018, 2204, 2123,
     2127, 2131, 2135, 2139, 2143, 2147, 2151, 2155, 2159, 2163,
       61, 2167, 2171,   55, 2175, 2179, 2183, 2187, 2191, 2195,
     2199
    } ;

static yyconst short int yy_def[282] =
    {   0,
      259,    1,  260,  260,  261,  261,  259,    7,    7,    9,
      259,  262,  262,  263,  264,  262,  262,  265,  259,  262,
      262,  262,  262,  262,  262,  262,  259,   27,   27,   27,
      262,  259,  262,  259,  259,  259,  259,  266,  259,  259,
      259,  267,  268,  268,  263,  263,  268,  268,  269,  259,
      268,  268,  268,  268,  268,  268,  268,  259,   58,   58,
       58,   58,   58,   58,   58,   58,   58,  268,  268,  259,
      268,   58,   58,   58,   58,  262,  259,  262,   19,  263,
      259,  264,  263,  264,  259,  262,  265,  259,  265,  259,
      259,  262,  262,  262,  262,  262,  262,  262,  262,  262,

      262,  270,   27,  262,   27,   27,   27,   32,  262,  259,
      259,  266,  259,  259,  259,  259,  259,  259,  259,  259,
      259,  259,  259,  271,  268,   50,  263,  268,  269,  259,
      259,  259,  268,  268,  268,  268,  268,  268,  268,  268,
      268,  268,  272,   58,  268,   58,   58,   58,   58,   58,
       58,   58,   70,  268,   58,   58,   58,   58,  259,  259,
      259,  259,  259,  273,  259,  273,  259,   91,  262,  262,
      270,  270,  259,  270,   27,   27,  259,  259,  274,  259,
      275,  259,  259,  132,  268,  268,  272,  259,  272,   58,
      268,  268,  268,  268,   58,  268,  268,   58,  268,  268,

      268,  268,  268,  268,   58,  276,  259,  160,  277,  277,
      259,  161,  278,  259,  278,  259,  163,  259,   91,  259,
      270,  270,  259,  259,  279,  259,  259,  180,  132,  259,
      272,  272,   58,   58,  160,  161,  259,  163,  280,  280,
      259,  280,  220,  180,  281,  259,  281,  230,  268,  268,
      268,  268,  220,  280,  280,  230,  281,  281,    0,  259,
      259,  259,  259,  259,  259,  259,  259,  259,  259,  259,
      259,  259,  259,  259,  259,  259,  259,  259,  259,  259,
      259
    } ;

static yyconst short int yy_nxt[2255] =
    {   0,
       12,   13,   14,   15,   16,   17,   18,   19,   20,   12,
       12,   12,   12,   21,   22,   23,   23,   24,   25,   26,
       27,   28,   28,   28,   28,   28,   28,   28,   28,   29,
       30,   28,   28,   28,   28,   28,   28,   31,   12,   12,
       32,   27,   28,   28,   29,   28,   28,   28,   28,   33,
       35,   36,   35,   36,   39,   40,  126,   41,  224,   37,
      135,   37,   39,   40,  179,   41,   77,   78,   77,   78,
      126,   79,  126,   79,   83,   84,   77,   78,  103,   85,
      126,   79,   77,   78,   88,   89,  127,   79,  126,   90,
       42,   81,   86,  103,  126,  133,  134,  134,   42,   43,

       44,   45,   46,   47,   48,   49,   50,   51,   43,   43,
       43,   43,   52,   53,   54,   54,   55,   56,   57,   58,
       59,   59,   59,   60,   61,   59,   59,   59,   62,   63,
       59,   64,   65,   59,   66,   67,   68,   43,   69,   70,
       58,   59,   60,   62,   64,   59,   59,   66,   71,   72,
       73,   77,   78,  126,   77,   78,   79,   74,   75,   79,
       59,   59,  126,   94,   43,  126,   77,   78,   72,  126,
       74,   79,   92,   59,   76,   76,   77,   78,   76,   76,
       76,   79,   76,   76,   76,   76,   76,   76,   76,   76,
       76,   76,   76,   76,   91,   91,   91,   91,   91,   91,

       91,   91,   91,   91,   91,   91,   91,   91,   91,   91,
       91,   76,   76,   76,   76,   91,   91,   91,   91,   91,
       91,   91,   91,   76,   77,   78,  126,  103,  106,   79,
       77,   78,  177,  178,  130,   79,  126,   93,   93,  131,
      126,   95,  103,   96,   96,   77,   78,   77,   78,  126,
       79,   97,   79,   77,   78,  126,  126,  126,   79,  126,
      128,   98,   86,   99,  178,  178,  139,  128,  140,  100,
       76,  101,   77,   78,   76,   76,   76,   79,   76,  102,
       76,   76,   76,   76,   76,  103,  103,   76,  104,   76,
      103,  103,  103,  103,  103,  103,  103,  103,  103,  105,

      103,  103,  103,  103,  103,  103,  103,   76,   76,   76,
      103,  103,  103,  103,  105,  103,  103,  103,  103,   76,
      103,  126,  126,  107,   77,   78,  159,   78,  130,   79,
      126,   79,  141,  131,  126,  103,  107,   76,  101,   77,
       78,   76,   76,   76,   79,   76,  102,   76,   76,   76,
       76,   76,  108,  108,   76,  104,   76,  108,  108,  108,
      108,  108,  108,  108,  108,  108,  108,  108,  108,  108,
      108,  108,  108,  108,   76,   76,   76,  108,  108,  108,
      108,  108,  108,  108,  108,  108,   76,   77,   78,  126,
      126,  144,   79,  144,  149,  136,  144,  137,  137,  144,

      147,  144,  182,  148,  150,  138,  144,  183,  144,  144,
      144,  144,  144,  151,  144,  144,  144,  150,  125,  155,
      188,  152,  144,  189,  144,  144,  103,  144,  103,  144,
      144,  126,  154,  156,  109,  115,  116,  144,  144,  158,
      144,  103,  157,  103,  144,   77,   84,  159,   84,  175,
       85,  126,   85,  144,   81,  144,  103,  223,  178,  134,
      134,  117,  118,  119,  120,  121,  122,  123,  124,  125,
      125,  103,  125,  125,  125,  125,  126,  125,  125,  125,
      125,  125,  125,  125,  125,  125,  125,  125,  125,  132,
      132,  132,  132,  132,  132,  132,  132,  132,  132,  132,

      132,  132,  132,  132,  132,  132,  125,  125,  125,  125,
      132,  132,  132,  132,  132,  132,  132,  132,  125,  125,
      142,  126,  125,  125,  125,  125,  126,  125,  143,  125,
      125,  125,  125,  125,  144,  144,  125,  145,  125,  144,
      144,  144,  144,  144,  144,  144,  144,  144,  146,  144,
      144,  144,  144,  144,  144,  144,  125,  125,  125,  144,
      144,  144,  144,  146,  144,  144,  144,  144,  125,  125,
      142,   81,  125,  125,  125,  125,  126,  125,  143,  125,
      125,  125,  125,  125,  153,  153,  125,  145,  125,  153,
      153,  153,  153,  153,  153,  153,  153,  153,  153,  153,

      153,  153,  153,  153,  153,  153,  125,  125,  125,  153,
      153,  153,  153,  153,  153,  153,  153,  153,  125,   80,
       80,   81,   80,   80,   80,   80,   81,   80,   80,   80,
       80,   80,   80,   80,   80,   80,   80,   80,   80,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,   80,   80,   80,   80,
      160,  160,  160,  160,  160,  160,  160,  160,   80,   82,
       82,   77,   84,   82,   82,   82,   85,   82,   82,   82,
       82,   82,   82,   82,   82,   82,   82,   82,   82,  161,
      161,  161,  161,  161,  161,  161,  161,  161,  161,  161,

      161,  161,  161,  161,  161,  161,   82,   82,   82,   82,
      161,  161,  161,  161,  161,  161,  161,  161,   82,   77,
       78,   88,   89,  126,   79,  126,   90,  162,   89,  178,
      178,  126,   90,   87,   87,   88,   89,   87,   87,   87,
       90,   87,   87,   87,   87,   87,   87,   87,   87,   87,
       87,   87,   87,  163,  163,  163,  163,  163,  163,  163,
      163,  163,  163,  163,  163,  163,  163,  163,  163,  163,
       87,   87,   87,   87,  163,  163,  163,  163,  163,  163,
      163,  163,   87,  164,  164,  165,  166,  164,  164,  164,
      167,  164,  164,  164,  164,  164,  164,  164,  168,  168,

      164,  164,  164,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      164,  164,  164,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  164,   77,   78,   77,   78,  142,   79,   81,
       79,   77,   78,  126,  144,  143,   79,  126,   93,   93,
       77,   78,  144,  126,  145,   79,   97,   77,   78,  144,
       77,   78,   79,   93,   93,   79,  103,  144,   95,  113,
       96,   96,   77,   78,   77,   78,  111,   79,   97,   79,
      110,  103,  169,   77,   78,  170,  170,  182,   79,  101,
       77,   78,  207,   77,  172,   79,   76,  102,  173,   77,

       78,  174,  103,  103,   79,   81,  104,  176,   77,   78,
      165,  166,  259,   79,  259,  167,  259,  103,  103,  176,
      129,  129,  130,  129,  129,  129,  129,  131,  129,  129,
      129,  129,  129,  129,  129,  129,  129,  129,  129,  129,
      180,  180,  180,  180,  180,  180,  180,  180,  180,  180,
      180,  180,  180,  180,  180,  180,  180,  129,  129,  129,
      129,  180,  180,  180,  180,  180,  180,  180,  180,  129,
      181,  181,  182,  181,  181,  181,  181,  183,  181,  181,
      181,  181,  181,  181,  181,  184,  184,  181,  181,  181,
      184,  184,  184,  184,  184,  184,  184,  184,  184,  184,

      184,  184,  184,  184,  184,  184,  184,  181,  181,  181,
      184,  184,  184,  184,  184,  184,  184,  184,  184,  181,
      126,  191,  193,  259,  126,  196,  126,  259,  134,  134,
      136,  185,  137,  137,  186,  186,  138,  190,  192,  194,
      138,  144,  197,  198,  144,  144,  195,  144,  259,  144,
      144,  144,  199,  144,  201,  203,  144,  259,  195,  144,
      144,  205,  144,  144,  144,  144,  144,  259,  144,  200,
      259,  202,  204,  259,  218,  166,   77,   78,  144,  167,
      144,   79,  144,  144,  126,  259,  125,  259,  188,  170,
      170,  189,  186,  186,  259,  144,  259,  144,  144,  206,

      206,  182,  206,  206,  206,  206,  207,  206,  206,  206,
      206,  206,  206,  206,  208,  208,  206,  206,  206,  208,
      208,  208,  208,  208,  208,  208,  208,  208,  208,  208,
      208,  208,  208,  208,  208,  208,  206,  206,  206,  208,
      208,  208,  208,  208,  208,  208,  208,  208,  206,  209,
      209,  165,  210,  209,  209,  209,  211,  209,  209,  209,
      209,  209,  209,  209,  212,  212,  209,  209,  209,  212,
      212,  212,  212,  212,  212,  212,  212,  212,  212,  212,
      212,  212,  212,  212,  212,  212,  209,  209,  209,  212,
      212,  212,  212,  212,  212,  212,  212,  212,  209,  213,

      213,  214,  215,  213,  213,  213,  216,  213,  213,  213,
      213,  213,  213,  213,  217,  217,  213,  213,  213,  217,
      217,  217,  217,  217,  217,  217,  217,  217,  217,  217,
      217,  217,  217,  217,  217,  217,  213,  213,  213,  217,
      217,  217,  217,  217,  217,  217,  217,  217,  213,  164,
      164,  165,  166,  164,  164,  164,  167,  164,  164,  164,
      164,  164,  164,  164,  164,  164,  164,  164,  164,  219,
      219,  219,  219,  219,  219,  219,  219,  219,  219,  219,
      219,  219,  219,  219,  219,  219,  164,  164,  164,  164,
      219,  219,  219,  219,  219,  219,  219,  219,  164,   77,

       78,  259,   77,  172,   79,   76,  144,  173,  233,  259,
      174,  226,  170,  170,  159,  172,  227,   76,  259,  173,
      259,  144,  174,  171,  171,   77,  172,  171,   76,  171,
      173,  171,  171,  174,  171,  171,  171,  171,  171,  171,
      171,  171,  171,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      171,  171,  171,  171,  220,  220,  220,  220,  220,  220,
      220,  220,  171,  221,   77,  172,  126,   76,  259,  173,
      178,  178,  174,  259,  186,  186,  259,  259,  259,  259,
      222,  225,  225,  226,  225,  225,  225,  225,  227,  225,

      225,  225,  225,  225,  225,  225,  228,  228,  225,  225,
      225,  228,  228,  228,  228,  228,  228,  228,  228,  228,
      228,  228,  228,  228,  228,  228,  228,  228,  225,  225,
      225,  228,  228,  228,  228,  228,  228,  228,  228,  228,
      225,  181,  181,  182,  181,  181,  181,  181,  183,  181,
      181,  181,  181,  181,  181,  181,  181,  181,  181,  181,
      181,  229,  229,  229,  229,  229,  229,  229,  229,  229,
      229,  229,  229,  229,  229,  229,  229,  229,  181,  181,
      181,  181,  229,  229,  229,  229,  229,  229,  229,  229,
      181,  187,  187,  259,  187,  187,  125,  187,  188,  187,

      187,  189,  187,  187,  187,  187,  187,  187,  187,  187,
      187,  230,  230,  230,  230,  230,  230,  230,  230,  230,
      230,  230,  230,  230,  230,  230,  230,  230,  187,  187,
      187,  187,  230,  230,  230,  230,  230,  230,  230,  230,
      187,  231,  144,  191,  234,  125,  193,  188,  259,  126,
      189,  143,  126,  196,  143,  259,  199,  144,  232,  126,
      192,  143,  126,  194,  143,  259,  201,  259,  259,  203,
      197,  259,  126,  200,  143,  126,  125,  143,  188,  165,
      210,  189,  259,  202,  211,  259,  204,  206,  206,  182,
      206,  206,  206,  206,  207,  206,  206,  206,  206,  206,

      206,  206,  206,  206,  206,  206,  206,  235,  235,  235,
      235,  235,  235,  235,  235,  235,  235,  235,  235,  235,
      235,  235,  235,  235,  206,  206,  206,  206,  235,  235,
      235,  235,  235,  235,  235,  235,  206,  218,  210,  259,
      259,  259,  211,  209,  209,  165,  210,  209,  209,  209,
      211,  209,  209,  209,  209,  209,  209,  209,  209,  209,
      209,  209,  209,  236,  236,  236,  236,  236,  236,  236,
      236,  236,  236,  236,  236,  236,  236,  236,  236,  236,
      209,  209,  209,  209,  236,  236,  236,  236,  236,  236,
      236,  236,  209,  214,  215,  237,  215,  259,  216,  259,

      216,  213,  213,  214,  215,  213,  213,  213,  216,  213,
      213,  213,  213,  213,  213,  213,  213,  213,  213,  213,
      213,  238,  238,  238,  238,  238,  238,  238,  238,  238,
      238,  238,  238,  238,  238,  238,  238,  238,  213,  213,
      213,  213,  238,  238,  238,  238,  238,  238,  238,  238,
      213,  239,  239,  165,  240,  239,  164,  239,  241,  239,
      239,  242,  239,  239,  239,  239,  243,  243,  239,  239,
      239,  243,  243,  243,  243,  243,  243,  243,  243,  243,
      243,  243,  243,  243,  243,  243,  243,  243,  239,  239,
      239,  243,  243,  243,  243,  243,  243,  243,  243,  243,

      239,  221,   77,  172,  259,   76,  259,  173,   77,  172,
      174,   76,  259,  173,  259,  259,  174,  259,  222,  225,
      225,  226,  225,  225,  225,  225,  227,  225,  225,  225,
      225,  225,  225,  225,  225,  225,  225,  225,  225,  244,
      244,  244,  244,  244,  244,  244,  244,  244,  244,  244,
      244,  244,  244,  244,  244,  244,  225,  225,  225,  225,
      244,  244,  244,  244,  244,  244,  244,  244,  225,  245,
      245,  182,  245,  245,  181,  245,  246,  245,  245,  247,
      245,  245,  245,  245,  248,  248,  245,  245,  245,  248,
      248,  248,  248,  248,  248,  248,  248,  248,  248,  248,

      248,  248,  248,  248,  248,  248,  245,  245,  245,  248,
      248,  248,  248,  248,  248,  248,  248,  248,  245,  231,
      249,  251,  259,  125,  249,  188,  165,  240,  189,  164,
      126,  241,  143,  259,  242,  259,  232,  250,  252,  218,
      240,  250,  164,  259,  241,  259,  259,  242,  144,  144,
      182,  165,  240,  181,  164,  246,  241,  259,  247,  242,
      259,  259,  259,  144,  144,  239,  239,  165,  240,  239,
      164,  239,  241,  239,  239,  242,  239,  239,  239,  239,
      239,  239,  239,  239,  239,  253,  253,  253,  253,  253,
      253,  253,  253,  253,  253,  253,  253,  253,  253,  253,

      253,  253,  239,  239,  239,  239,  253,  253,  253,  253,
      253,  253,  253,  253,  239,  254,  165,  240,  259,  164,
      182,  241,  259,  181,  242,  246,  259,  259,  247,  259,
      259,  259,  255,  245,  245,  182,  245,  245,  181,  245,
      246,  245,  245,  247,  245,  245,  245,  245,  245,  245,
      245,  245,  245,  256,  256,  256,  256,  256,  256,  256,
      256,  256,  256,  256,  256,  256,  256,  256,  256,  256,
      245,  245,  245,  245,  256,  256,  256,  256,  256,  256,
      256,  256,  245,  257,  182,  251,  259,  181,  259,  246,
      259,  126,  247,  143,  259,  254,  165,  240,  259,  164,

      258,  241,  252,  259,  242,  257,  182,  259,  259,  181,
      259,  246,  255,  259,  247,  259,  259,  259,  259,  259,
      259,  259,  258,   34,   34,   34,   34,   38,   38,   38,
       38,   76,   76,   76,   76,   80,  259,   80,   80,   82,
       82,   82,   82,   87,   87,   87,   87,  112,  259,  259,
      112,  114,  114,  114,  114,  125,  259,  125,  125,  129,
      129,  129,  129,  171,  171,  171,  171,  187,  259,  187,
      187,  164,  164,  164,  164,  181,  181,  181,  181,  206,
      206,  206,  206,  209,  209,  209,  209,  213,  213,  213,
      213,  225,  225,  225,  225,  239,  239,  239,  239,  245,

      245,  245,  245,   11,  259,  259,  259,  259,  259,  259,
      259,  259,  259,  259,  259,  259,  259,  259,  259,  259,
      259,  259,  259,  259,  259,  259,  259,  259,  259,  259,
      259,  259,  259,  259,  259,  259,  259,  259,  259,  259,
      259,  259,  259,  259,  259,  259,  259,  259,  259,  259,
      259,  259,  259,  259
    } ;

static yyconst short int yy_chk[2255] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        3,    3,    4,    4,    5,    5,   53,    5,  274,    3,
       53,    4,    6,    6,  271,    6,   12,   12,   13,   13,
      252,   12,  250,   13,   15,   15,   16,   16,   28,   15,
      204,   16,   17,   17,   18,   18,   46,   17,   52,   18,
        5,   46,   16,   28,   51,   51,   52,   52,    6,    7,

        7,    7,    7,    7,    7,    7,    7,    7,    7,    7,
        7,    7,    7,    7,    7,    7,    7,    7,    7,    7,
        7,    7,    7,    7,    7,    7,    7,    7,    7,    7,
        7,    7,    7,    7,    7,    7,    7,    7,    7,    7,
        7,    7,    7,    7,    7,    7,    7,    7,    7,    9,
        9,   31,   31,  202,   22,   22,   31,    9,    9,   22,
        9,    9,  200,   22,    9,  197,   20,   20,    9,  194,
        9,   20,   20,    9,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,

       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   21,   21,  192,   29,   29,   21,
       23,   23,  115,  115,   49,   23,  154,   21,   21,   49,
      145,   23,   29,   23,   23,   24,   24,   25,   25,   47,
       24,   23,   25,   26,   26,   55,  141,   56,   26,  140,
       47,   24,   24,   25,  116,  116,   55,   55,   56,   26,
       27,   27,   27,   27,   27,   27,   27,   27,   27,   27,
       27,   27,   27,   27,   27,   27,   27,   27,   27,   27,
       27,   27,   27,   27,   27,   27,   27,   27,   27,   27,

       27,   27,   27,   27,   27,   27,   27,   27,   27,   27,
       27,   27,   27,   27,   27,   27,   27,   27,   27,   27,
       30,   57,  139,   30,   76,   76,   78,   78,  129,   76,
      135,   78,   57,  129,  133,   30,   30,   32,   32,   32,
       32,   32,   32,   32,   32,   32,   32,   32,   32,   32,
       32,   32,   32,   32,   32,   32,   32,   32,   32,   32,
       32,   32,   32,   32,   32,   32,   32,   32,   32,   32,
       32,   32,   32,   32,   32,   32,   32,   32,   32,   32,
       32,   32,   32,   32,   32,   32,   32,   33,   33,   54,
       71,   59,   33,   62,   62,   54,   60,   54,   54,   61,

       60,   63,  181,   61,   63,   54,   59,  181,   62,   64,
       66,   60,   67,   64,   61,   72,   63,   63,  143,   72,
      143,   65,   65,  143,   64,   66,  103,   67,  107,   73,
       72,  128,   71,   73,   33,   42,   42,   65,   74,   75,
       75,  103,   74,  107,   73,   82,   82,   84,   84,  105,
       82,  136,   84,   74,  127,   75,  105,  177,  177,  136,
      136,   42,   42,   42,   42,   42,   42,   42,   42,   50,
       50,  105,   50,   50,   50,   50,   50,   50,   50,   50,
       50,   50,   50,   50,   50,   50,   50,   50,   50,   50,
       50,   50,   50,   50,   50,   50,   50,   50,   50,   50,

       50,   50,   50,   50,   50,   50,   50,   50,   50,   50,
       50,   50,   50,   50,   50,   50,   50,   50,   50,   58,
       58,  125,   58,   58,   58,   58,   58,   58,   58,   58,
       58,   58,   58,   58,   58,   58,   58,   58,   58,   58,
       58,   58,   58,   58,   58,   58,   58,   58,   58,   58,
       58,   58,   58,   58,   58,   58,   58,   58,   58,   58,
       58,   58,   58,   58,   58,   58,   58,   58,   58,   70,
       70,   83,   70,   70,   70,   70,   70,   70,   70,   70,
       70,   70,   70,   70,   70,   70,   70,   70,   70,   70,
       70,   70,   70,   70,   70,   70,   70,   70,   70,   70,

       70,   70,   70,   70,   70,   70,   70,   70,   70,   70,
       70,   70,   70,   70,   70,   70,   70,   70,   70,   81,
       81,   80,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   85,
       85,   85,   85,   85,   85,   85,   85,   85,   85,   85,
       85,   85,   85,   85,   85,   85,   85,   85,   85,   85,
       85,   85,   85,   85,   85,   85,   85,   85,   85,   85,

       85,   85,   85,   85,   85,   85,   85,   85,   85,   85,
       85,   85,   85,   85,   85,   85,   85,   85,   85,   86,
       86,   87,   87,   69,   86,   68,   87,   89,   89,  178,
      178,   48,   89,   90,   90,   90,   90,   90,   90,   90,
       90,   90,   90,   90,   90,   90,   90,   90,   90,   90,
       90,   90,   90,   90,   90,   90,   90,   90,   90,   90,
       90,   90,   90,   90,   90,   90,   90,   90,   90,   90,
       90,   90,   90,   90,   90,   90,   90,   90,   90,   90,
       90,   90,   90,   91,   91,   91,   91,   91,   91,   91,
       91,   91,   91,   91,   91,   91,   91,   91,   91,   91,

       91,   91,   91,   91,   91,   91,   91,   91,   91,   91,
       91,   91,   91,   91,   91,   91,   91,   91,   91,   91,
       91,   91,   91,   91,   91,   91,   91,   91,   91,   91,
       91,   91,   91,   92,   92,   93,   93,  142,   92,   45,
       93,   94,   94,  142,  144,  142,   94,   44,   93,   93,
       95,   95,  150,   43,  142,   95,   93,   96,   96,  144,
       98,   98,   96,   95,   95,   98,  175,  150,   96,   40,
       96,   96,   97,   97,   99,   99,   37,   97,   96,   99,
       36,  175,   97,  100,  100,   97,   97,  206,  100,  101,
      101,  101,  206,  102,  102,  101,  102,  101,  102,  104,

      104,  102,  106,  176,  104,   14,  101,  106,  109,  109,
      164,  164,   11,  109,    0,  164,    0,  106,  176,  106,
      131,  131,  131,  131,  131,  131,  131,  131,  131,  131,
      131,  131,  131,  131,  131,  131,  131,  131,  131,  131,
      131,  131,  131,  131,  131,  131,  131,  131,  131,  131,
      131,  131,  131,  131,  131,  131,  131,  131,  131,  131,
      131,  131,  131,  131,  131,  131,  131,  131,  131,  131,
      132,  132,  132,  132,  132,  132,  132,  132,  132,  132,
      132,  132,  132,  132,  132,  132,  132,  132,  132,  132,
      132,  132,  132,  132,  132,  132,  132,  132,  132,  132,

      132,  132,  132,  132,  132,  132,  132,  132,  132,  132,
      132,  132,  132,  132,  132,  132,  132,  132,  132,  132,
      134,  147,  148,    0,  137,  151,  138,    0,  134,  134,
      137,  138,  137,  137,  138,  138,  134,  146,  147,  148,
      137,  149,  151,  152,  146,  152,  149,  190,    0,  147,
      148,  195,  155,  151,  156,  157,  149,    0,  149,  146,
      152,  158,  190,  158,  147,  148,  195,    0,  151,  155,
        0,  156,  157,    0,  166,  166,  169,  169,  158,  166,
      155,  169,  156,  157,  185,    0,  187,    0,  187,  169,
      169,  187,  185,  185,    0,  155,    0,  156,  157,  160,

      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  161,
      161,  161,  161,  161,  161,  161,  161,  161,  161,  161,
      161,  161,  161,  161,  161,  161,  161,  161,  161,  161,
      161,  161,  161,  161,  161,  161,  161,  161,  161,  161,
      161,  161,  161,  161,  161,  161,  161,  161,  161,  161,
      161,  161,  161,  161,  161,  161,  161,  161,  161,  163,

      163,  163,  163,  163,  163,  163,  163,  163,  163,  163,
      163,  163,  163,  163,  163,  163,  163,  163,  163,  163,
      163,  163,  163,  163,  163,  163,  163,  163,  163,  163,
      163,  163,  163,  163,  163,  163,  163,  163,  163,  163,
      163,  163,  163,  163,  163,  163,  163,  163,  163,  167,
      167,  167,  167,  167,  167,  167,  167,  167,  167,  167,
      167,  167,  167,  167,  167,  167,  167,  167,  167,  167,
      167,  167,  167,  167,  167,  167,  167,  167,  167,  167,
      167,  167,  167,  167,  167,  167,  167,  167,  167,  167,
      167,  167,  167,  167,  167,  167,  167,  167,  167,  170,

      170,    0,  171,  171,  170,  171,  198,  171,  198,    0,
      171,  225,  170,  170,  172,  172,  225,  172,    0,  172,
        0,  198,  172,  173,  173,  173,  173,  173,  173,  173,
      173,  173,  173,  173,  173,  173,  173,  173,  173,  173,
      173,  173,  173,  173,  173,  173,  173,  173,  173,  173,
      173,  173,  173,  173,  173,  173,  173,  173,  173,  173,
      173,  173,  173,  173,  173,  173,  173,  173,  173,  173,
      173,  173,  173,  174,  174,  174,  186,  174,    0,  174,
      223,  223,  174,    0,  186,  186,    0,    0,    0,    0,
      174,  180,  180,  180,  180,  180,  180,  180,  180,  180,

      180,  180,  180,  180,  180,  180,  180,  180,  180,  180,
      180,  180,  180,  180,  180,  180,  180,  180,  180,  180,
      180,  180,  180,  180,  180,  180,  180,  180,  180,  180,
      180,  180,  180,  180,  180,  180,  180,  180,  180,  180,
      180,  183,  183,  183,  183,  183,  183,  183,  183,  183,
      183,  183,  183,  183,  183,  183,  183,  183,  183,  183,
      183,  183,  183,  183,  183,  183,  183,  183,  183,  183,
      183,  183,  183,  183,  183,  183,  183,  183,  183,  183,
      183,  183,  183,  183,  183,  183,  183,  183,  183,  183,
      183,  188,  188,    0,  188,  188,  188,  188,  188,  188,

      188,  188,  188,  188,  188,  188,  188,  188,  188,  188,
      188,  188,  188,  188,  188,  188,  188,  188,  188,  188,
      188,  188,  188,  188,  188,  188,  188,  188,  188,  188,
      188,  188,  188,  188,  188,  188,  188,  188,  188,  188,
      188,  189,  205,  191,  205,  189,  193,  189,    0,  191,
      189,  191,  193,  196,  193,    0,  199,  205,  189,  196,
      191,  196,  199,  193,  199,    0,  201,    0,    0,  203,
      196,    0,  201,  199,  201,  203,  232,  203,  232,  209,
      209,  232,    0,  201,  209,    0,  203,  207,  207,  207,
      207,  207,  207,  207,  207,  207,  207,  207,  207,  207,

      207,  207,  207,  207,  207,  207,  207,  207,  207,  207,
      207,  207,  207,  207,  207,  207,  207,  207,  207,  207,
      207,  207,  207,  207,  207,  207,  207,  207,  207,  207,
      207,  207,  207,  207,  207,  207,  207,  210,  210,    0,
        0,    0,  210,  211,  211,  211,  211,  211,  211,  211,
      211,  211,  211,  211,  211,  211,  211,  211,  211,  211,
      211,  211,  211,  211,  211,  211,  211,  211,  211,  211,
      211,  211,  211,  211,  211,  211,  211,  211,  211,  211,
      211,  211,  211,  211,  211,  211,  211,  211,  211,  211,
      211,  211,  211,  213,  213,  215,  215,    0,  213,    0,

      215,  216,  216,  216,  216,  216,  216,  216,  216,  216,
      216,  216,  216,  216,  216,  216,  216,  216,  216,  216,
      216,  216,  216,  216,  216,  216,  216,  216,  216,  216,
      216,  216,  216,  216,  216,  216,  216,  216,  216,  216,
      216,  216,  216,  216,  216,  216,  216,  216,  216,  216,
      216,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,

      220,  221,  221,  221,    0,  221,    0,  221,  222,  222,
      221,  222,    0,  222,    0,    0,  222,    0,  221,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  230,
      230,  230,  230,  230,  230,  230,  230,  230,  230,  230,
      230,  230,  230,  230,  230,  230,  230,  230,  230,  230,
      230,  230,  230,  230,  230,  230,  230,  230,  230,  230,

      230,  230,  230,  230,  230,  230,  230,  230,  230,  230,
      230,  230,  230,  230,  230,  230,  230,  230,  230,  231,
      233,  234,    0,  231,  249,  231,  239,  239,  231,  239,
      249,  239,  249,    0,  239,    0,  231,  233,  234,  240,
      240,  249,  240,    0,  240,    0,    0,  240,  233,  234,
      245,  255,  255,  245,  255,  245,  255,    0,  245,  255,
        0,    0,    0,  233,  234,  241,  241,  241,  241,  241,
      241,  241,  241,  241,  241,  241,  241,  241,  241,  241,
      241,  241,  241,  241,  241,  241,  241,  241,  241,  241,
      241,  241,  241,  241,  241,  241,  241,  241,  241,  241,

      241,  241,  241,  241,  241,  241,  241,  241,  241,  241,
      241,  241,  241,  241,  241,  242,  242,  242,    0,  242,
      258,  242,    0,  258,  242,  258,    0,    0,  258,    0,
        0,    0,  242,  246,  246,  246,  246,  246,  246,  246,
      246,  246,  246,  246,  246,  246,  246,  246,  246,  246,
      246,  246,  246,  246,  246,  246,  246,  246,  246,  246,
      246,  246,  246,  246,  246,  246,  246,  246,  246,  246,
      246,  246,  246,  246,  246,  246,  246,  246,  246,  246,
      246,  246,  246,  247,  247,  251,    0,  247,    0,  247,
        0,  251,  247,  251,    0,  254,  254,  254,    0,  254,

      247,  254,  251,    0,  254,  257,  257,    0,    0,  257,
        0,  257,  254,    0,  257,    0,    0,    0,    0,    0,
        0,    0,  257,  260,  260,  260,  260,  261,  261,  261,
      261,  262,  262,  262,  262,  263,    0,  263,  263,  264,
      264,  264,  264,  265,  265,  265,  265,  266,    0,    0,
      266,  267,  267,  267,  267,  268,    0,  268,  268,  269,
      269,  269,  269,  270,  270,  270,  270,  272,    0,  272,
      272,  273,  273,  273,  273,  275,  275,  275,  275,  276,
      276,  276,  276,  277,  277,  277,  277,  278,  278,  278,
      278,  279,  279,  279,  279,  280,  280,  280,  280,  281,

      281,  281,  281,  259,  259,  259,  259,  259,  259,  259,
      259,  259,  259,  259,  259,  259,  259,  259,  259,  259,
      259,  259,  259,  259,  259,  259,  259,  259,  259,  259,
      259,  259,  259,  259,  259,  259,  259,  259,  259,  259,
      259,  259,  259,  259,  259,  259,  259,  259,  259,  259,
      259,  259,  259,  259
    } ;

static yy_state_type yy_state_buf[YY_BUF_SIZE + 2], *yy_state_ptr;
static char *yy_full_match;
static int yy_lp;
static int yy_looking_for_trail_begin = 0;
static int yy_full_lp;
static int *yy_full_state;
#define YY_TRAILING_MASK 0x2000
#define YY_TRAILING_HEAD_MASK 0x4000
#define REJECT \
{ \
*yy_cp = yy_hold_char; /* undo effects of setting up yytext */ \
yy_cp = yy_full_match; /* restore poss. backed-over text */ \
yy_lp = yy_full_lp; /* restore orig. accepting pos. */ \
yy_state_ptr = yy_full_state; /* restore orig. state */ \
yy_current_state = *yy_state_ptr; /* restore curr. state */ \
++yy_lp; \
goto find_rule; \
}
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
char *yytext;
#line 1 "control_lex.l"
#define INITIAL 0
#line 2 "control_lex.l"
/****************************************************************************
 *                                                                          *
 *     Loki - Programs for genetic analysis of complex traits using MCMC    *
 *                                                                          *
 *             Simon Heath - University of Washington                       *
 *                                                                          *
 *                       March 1997                                         *
 *                                                                          *
 * control_lex.l:                                                           *
 *                                                                          *
 * flex (NOT lex!) source for control file lexer.                           *
 *                                                                          *
 ****************************************************************************/

#include <config.h>
#include <stdlib.h>
#include <string.h>
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
#ifdef USE_DMALLOC
#include <dmalloc.h>
#endif
#include <ctype.h>
#include <sys/stat.h>
	
#include "control_parse.h"
#include "scan.h"
#include "scanner.h"
#include "utils.h"

#define YY_DECL int yy_orig_lex YY_PROTO(( void ))
#define MAX_STRING 512
#define LINEBUFSIZE 4096
#ifndef YY_STACK_USED
#define YY_STACK_USED 0
#endif
#ifndef YY_ALWAYS_INTERACTIVE
#define YY_ALWAYS_INTERACTIVE 0
#endif
#ifndef YY_NEVER_INTERACTIVE
#define YY_NEVER_INTERACTIVE 0
#endif
#ifndef YY_MAIN
#define YY_MAIN 0
#endif
	
int lineno=1,lineno1=1,at_file,at_model,at_use,begin_comm;
char linebuf[LINEBUFSIZE],linebuf1[LINEBUFSIZE];
static char *get_string(char *s,int size);
static YY_BUFFER_STATE bufstate_list[MAX_INCLUDE];
char *fname_list[MAX_INCLUDE+1];
int list_ptr;

static int tokenpos,stringbuf_ptr,ff_flag,ln_list[MAX_INCLUDE],ln1_list[MAX_INCLUDE];
static char stringbuf[MAX_STRING];
static void process_env_var(char *ptr);
static void append_to_sbuf(int *sptr,char c);

#define COMMENT 1

#define STR 2
 
#define ATFORMAT 3

#define ISTATE 4

#line 1076 "lex.yy.c"

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int yywrap YY_PROTO(( void ));
#else
extern int yywrap YY_PROTO(( void ));
#endif
#endif

#ifndef YY_NO_UNPUT
static void yyunput YY_PROTO(( int c, char *buf_ptr ));
#endif

#ifndef yytext_ptr
static void yy_flex_strncpy YY_PROTO(( char *, yyconst char *, int ));
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen YY_PROTO(( yyconst char * ));
#endif

#ifndef YY_NO_INPUT
#ifdef __cplusplus
static int yyinput YY_PROTO(( void ));
#else
static int input YY_PROTO(( void ));
#endif
#endif

#if YY_STACK_USED
static int yy_start_stack_ptr = 0;
static int yy_start_stack_depth = 0;
static int *yy_start_stack = 0;
#ifndef YY_NO_PUSH_STATE
static void yy_push_state YY_PROTO(( int new_state ));
#endif
#ifndef YY_NO_POP_STATE
static void yy_pop_state YY_PROTO(( void ));
#endif
#ifndef YY_NO_TOP_STATE
static int yy_top_state YY_PROTO(( void ));
#endif

#else
#define YY_NO_PUSH_STATE 1
#define YY_NO_POP_STATE 1
#define YY_NO_TOP_STATE 1
#endif

#ifdef YY_MALLOC_DECL
YY_MALLOC_DECL
#else
#ifdef __STDC__
#ifndef __cplusplus
#include <stdlib.h>
#endif
#else
/* Just try to get by without declaring the routines.  This will fail
 * miserably on non-ANSI systems for which sizeof(size_t) != sizeof(int)
 * or sizeof(void*) != sizeof(int).
 */
#endif
#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#define YY_READ_BUF_SIZE 8192
#endif

/* Copy whatever the last rule matched to the standard output. */

#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO (void) fwrite( yytext, yyleng, 1, yyout )
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( yy_current_buffer->yy_is_interactive ) \
		{ \
		int c = '*', n; \
		for ( n = 0; n < max_size && \
			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( yyin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else if ( ((result = fread( buf, 1, max_size, yyin )) == 0) \
		  && ferror( yyin ) ) \
		YY_FATAL_ERROR( "input in flex scanner failed" );
#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
#endif

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL int yylex YY_PROTO(( void ))
#endif

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK break;
#endif

#define YY_RULE_SETUP \
	YY_USER_ACTION

YY_DECL
	{
	register yy_state_type yy_current_state;
	register char *yy_cp, *yy_bp;
	register int yy_act;

#line 70 "control_lex.l"



	int token;


#line 1234 "lex.yy.c"

	if ( yy_init )
		{
		yy_init = 0;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if ( ! yy_start )
			yy_start = 1;	/* first start state */

		if ( ! yyin )
			yyin = stdin;

		if ( ! yyout )
			yyout = stdout;

		if ( ! yy_current_buffer )
			yy_current_buffer =
				yy_create_buffer( yyin, YY_BUF_SIZE );

		yy_load_buffer_state();
		}

	while ( 1 )		/* loops until end-of-file is reached */
		{
		yy_cp = yy_c_buf_p;

		/* Support of yytext. */
		*yy_cp = yy_hold_char;

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = yy_start;
		yy_state_ptr = yy_state_buf;
		*yy_state_ptr++ = yy_current_state;
yy_match:
		do
			{
			register YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)];
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 260 )
					yy_c = yy_meta[(unsigned int) yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
			*yy_state_ptr++ = yy_current_state;
			++yy_cp;
			}
		while ( yy_base[yy_current_state] != 2204 );

yy_find_action:
		yy_current_state = *--yy_state_ptr;
		yy_lp = yy_accept[yy_current_state];
find_rule: /* we branch to this label when backing up */
		for ( ; ; ) /* until we find what rule we matched */
			{
			if ( yy_lp && yy_lp < yy_accept[yy_current_state + 1] )
				{
				yy_act = yy_acclist[yy_lp];
				if ( yy_act & YY_TRAILING_HEAD_MASK ||
				     yy_looking_for_trail_begin )
					{
					if ( yy_act == yy_looking_for_trail_begin )
						{
						yy_looking_for_trail_begin = 0;
						yy_act &= ~YY_TRAILING_HEAD_MASK;
						break;
						}
					}
				else if ( yy_act & YY_TRAILING_MASK )
					{
					yy_looking_for_trail_begin = yy_act & ~YY_TRAILING_MASK;
					yy_looking_for_trail_begin |= YY_TRAILING_HEAD_MASK;
					}
				else
					{
					yy_full_match = yy_cp;
					yy_full_state = yy_state_ptr;
					yy_full_lp = yy_lp;
					break;
					}
				++yy_lp;
				goto find_rule;
				}
			--yy_cp;
			yy_current_state = *--yy_state_ptr;
			yy_lp = yy_accept[yy_current_state];
			}

		YY_DO_BEFORE_ACTION;


do_action:	/* This label is used only to access EOF actions. */


		switch ( yy_act )
	{ /* beginning of action switch */
case YY_STATE_EOF(INITIAL):
case YY_STATE_EOF(COMMENT):
case YY_STATE_EOF(STR):
case YY_STATE_EOF(ATFORMAT):
case YY_STATE_EOF(ISTATE):
#line 76 "control_lex.l"
{
	if(iflag) {
		iflag=0;
		return BREAK;
	}
	if(--list_ptr<0) yyterminate();
	else {
		free(fname_list[list_ptr+1]);
		yy_delete_buffer(YY_CURRENT_BUFFER);
		yy_switch_to_buffer(bufstate_list[list_ptr]);
		lineno=ln_list[list_ptr];
		lineno1=ln1_list[list_ptr];
		linebuf[0]=linebuf1[0]=0;
	}
}
	YY_BREAK
case 1:
*yy_cp = yy_hold_char; /* undo effects of setting up yytext */
yy_c_buf_p = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 92 "control_lex.l"
{ process_env_var(yytext); }
	YY_BREAK
case 2:
YY_RULE_SETUP
#line 94 "control_lex.l"
{
    (void)strncpy(linebuf,yytext,LINEBUFSIZE);
    (void)strcpy(linebuf1,linebuf);
    yyless((int)0);
    BEGIN ISTATE;
    }
	YY_BREAK
case 3:
YY_RULE_SETUP
#line 101 "control_lex.l"
{tokenpos+=yyleng;}
	YY_BREAK
case 4:
YY_RULE_SETUP
#line 103 "control_lex.l"
{ 
    lineno++;
    tokenpos=0;
    (void)strncpy(linebuf,yytext+1,LINEBUFSIZE);
    yyless((int)1);
    }
	YY_BREAK
case 5:
YY_RULE_SETUP
#line 110 "control_lex.l"
BEGIN(COMMENT);
	YY_BREAK
case 6:
YY_RULE_SETUP
#line 111 "control_lex.l"
{tokenpos+=yyleng;}
	YY_BREAK
case 7:
YY_RULE_SETUP
#line 112 "control_lex.l"
{lineno++; tokenpos=0;}
	YY_BREAK
case 8:
YY_RULE_SETUP
#line 113 "control_lex.l"
{BEGIN(ISTATE); tokenpos+=yyleng;}
	YY_BREAK
case 9:
*yy_cp = yy_hold_char; /* undo effects of setting up yytext */
yy_c_buf_p = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 115 "control_lex.l"
;
	YY_BREAK
case 10:
YY_RULE_SETUP
#line 117 "control_lex.l"
{ stringbuf_ptr=0;
       BEGIN(STR);
 	  tokenpos+=yyleng; }
	YY_BREAK
case 11:
YY_RULE_SETUP
#line 121 "control_lex.l"
{
           BEGIN(ISTATE);
	      append_to_sbuf(&stringbuf_ptr,'\0');
		 yylval.string=get_string(stringbuf,stringbuf_ptr);
		 tokenpos+=yyleng;
		 return STRING; 
	   }
	YY_BREAK
case 12:
YY_RULE_SETUP
#line 129 "control_lex.l"
{ BEGIN(ISTATE);
	     append_to_sbuf(&stringbuf_ptr,'\0');
		print_scan_warn("Line %d: Warning - Unterminanted string\n",lineno);
		tokenpos+=yyleng;
		yylval.string=get_string(stringbuf,stringbuf_ptr);
		return STRING; }
	YY_BREAK
case 13:
YY_RULE_SETUP
#line 136 "control_lex.l"
{ unsigned int result;
                    (void) sscanf(yytext+1,"%uo",&result);
				tokenpos+=yyleng;
				if(result>0xff) print_scan_err("Line %d: Error - Octal constant too large\n",lineno);
				append_to_sbuf(&stringbuf_ptr,(char)result); }
	YY_BREAK
case 14:
YY_RULE_SETUP
#line 142 "control_lex.l"
{ unsigned int result;
                    (void) sscanf(yytext+1,"%ux",&result);
				tokenpos+=yyleng;
 				append_to_sbuf(&stringbuf_ptr,(char)result); }
	YY_BREAK
case 15:
YY_RULE_SETUP
#line 147 "control_lex.l"
{ tokenpos+=yyleng;
                print_scan_err("Line %d: Error - Syntax error in escape sequence\n",lineno); }
	YY_BREAK
case 16:
YY_RULE_SETUP
#line 150 "control_lex.l"
{ tokenpos+=yyleng;
	     append_to_sbuf(&stringbuf_ptr,'\a'); }
	YY_BREAK
case 17:
YY_RULE_SETUP
#line 153 "control_lex.l"
{ tokenpos+=yyleng;
 	     append_to_sbuf(&stringbuf_ptr,'\b'); }
	YY_BREAK
case 18:
YY_RULE_SETUP
#line 156 "control_lex.l"
{ tokenpos+=yyleng;
	     append_to_sbuf(&stringbuf_ptr,'\f'); }
	YY_BREAK
case 19:
YY_RULE_SETUP
#line 159 "control_lex.l"
{ tokenpos+=yyleng;
	     append_to_sbuf(&stringbuf_ptr,'\n'); }
	YY_BREAK
case 20:
YY_RULE_SETUP
#line 162 "control_lex.l"
{ tokenpos+=yyleng;
	     append_to_sbuf(&stringbuf_ptr,'\r'); }
	YY_BREAK
case 21:
YY_RULE_SETUP
#line 165 "control_lex.l"
{ tokenpos+=yyleng;
	     append_to_sbuf(&stringbuf_ptr,'\t'); }
	YY_BREAK
case 22:
YY_RULE_SETUP
#line 168 "control_lex.l"
{ tokenpos+=yyleng;
	     append_to_sbuf(&stringbuf_ptr,'\v'); }
	YY_BREAK
case 23:
YY_RULE_SETUP
#line 171 "control_lex.l"
{ tokenpos++;
	     append_to_sbuf(&stringbuf_ptr,'\a'); }
	YY_BREAK
case 24:
YY_RULE_SETUP
#line 174 "control_lex.l"
{ char *ss=yytext;
                  tokenpos+=yyleng;
			   while(*ss) append_to_sbuf(&stringbuf_ptr,*ss++); }
	YY_BREAK
case 25:
YY_RULE_SETUP
#line 178 "control_lex.l"
{ if(at_file) BEGIN ATFORMAT;
     tokenpos+=yyleng;
     return '['; }
	YY_BREAK
case 26:
YY_RULE_SETUP
#line 182 "control_lex.l"
{ if(at_file) BEGIN ISTATE;
              tokenpos+=yyleng;
              return ']'; }
	YY_BREAK
case 27:
YY_RULE_SETUP
#line 186 "control_lex.l"
{ tokenpos+=yyleng; return('x'); }
	YY_BREAK
case 28:
YY_RULE_SETUP
#line 188 "control_lex.l"
{ tokenpos+=yyleng; return('y'); }
	YY_BREAK
case 29:
YY_RULE_SETUP
#line 190 "control_lex.l"
{ return LEQSYMBOL; }
	YY_BREAK
case 30:
YY_RULE_SETUP
#line 192 "control_lex.l"
{ return GEQSYMBOL; }
	YY_BREAK
case 31:
YY_RULE_SETUP
#line 194 "control_lex.l"
{ return NEQSYMBOL; }
	YY_BREAK
case 32:
YY_RULE_SETUP
#line 196 "control_lex.l"
{ return '='; }
	YY_BREAK
case 33:
YY_RULE_SETUP
#line 198 "control_lex.l"
{ return ORSYMBOL; }
	YY_BREAK
case 34:
YY_RULE_SETUP
#line 200 "control_lex.l"
{ return ANDSYMBOL; }
	YY_BREAK
case 35:
YY_RULE_SETUP
#line 202 "control_lex.l"
{ return NOTSYMBOL; }
	YY_BREAK
case 36:
YY_RULE_SETUP
#line 204 "control_lex.l"
{ return SKIPFORMAT; }
	YY_BREAK
case 37:
YY_RULE_SETUP
#line 205 "control_lex.l"
{ if(at_file) return SKIPFORMAT;
								  if(!ff_flag) {yyless(0); token=BREAK;}			 
                          else token=SKIPFORMAT;
	                       ff_flag^=1;
	                       return token; }
	YY_BREAK
case 38:
YY_RULE_SETUP
#line 210 "control_lex.l"
{ return RSFORMAT; }
	YY_BREAK
case 39:
YY_RULE_SETUP
#line 211 "control_lex.l"
{ if(at_file) return RSFORMAT;
								  if(!ff_flag) {yyless(0); token=BREAK;}
                          else token=RSFORMAT;
	                       ff_flag^=1;
	                       return token; }
	YY_BREAK
case 40:
YY_RULE_SETUP
#line 216 "control_lex.l"
{ return GSFORMAT; }
	YY_BREAK
case 41:
YY_RULE_SETUP
#line 217 "control_lex.l"
{ if(at_file) return GSFORMAT;
								  if(!ff_flag) {yyless(0); token=BREAK;}
                          else token=GSFORMAT;
	                       ff_flag^=1;
	                       return token; }
	YY_BREAK
case 42:
YY_RULE_SETUP
#line 223 "control_lex.l"
{ return FSFORMAT; }
	YY_BREAK
case 43:
YY_RULE_SETUP
#line 224 "control_lex.l"
{ if(at_file) return FSFORMAT;
								  if(!ff_flag) {yyless(0); token=BREAK;}
                          else token=FSFORMAT;
	                       ff_flag^=1;
	                       return token; }
	YY_BREAK
case 44:
YY_RULE_SETUP
#line 230 "control_lex.l"
{
                               token=symbol_lookup(yytext,1);
				           if(token==BREAK) yyless(0);
				           else
						 {
						   tokenpos+=yyleng;
						   if(!at_model && !at_use && (token==VARIABLE || token==ARRAY_VAR)) token=ASSIGN;
						 }
						 if((!at_model && !at_use) || token!=BREAK) return token;
					    }
	YY_BREAK
case 45:
YY_RULE_SETUP
#line 241 "control_lex.l"
{
	             token=symbol_lookup(yytext,0);
				    if(token==BREAK) yyless(0);
				    else tokenpos+=yyleng; 
				    return token; }
	YY_BREAK
case 46:
YY_RULE_SETUP
#line 247 "control_lex.l"
{
         tokenpos+=yyleng; yylval.rvalue=atof(yytext); return REAL; }
	YY_BREAK
case 47:
YY_RULE_SETUP
#line 250 "control_lex.l"
{ tokenpos+=yyleng; yylval.value=atoi(yytext); return INTEGER; }
	YY_BREAK
case 48:
YY_RULE_SETUP
#line 252 "control_lex.l"
{ tokenpos+=yyleng; return yytext[0]; }
	YY_BREAK
case 49:
YY_RULE_SETUP
#line 254 "control_lex.l"
ECHO;
	YY_BREAK
#line 1686 "lex.yy.c"

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - yytext_ptr) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = yy_hold_char;
		YY_RESTORE_YY_MORE_OFFSET

		if ( yy_current_buffer->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed yyin at a new source and called
			 * yylex().  If so, then we have to assure
			 * consistency between yy_current_buffer and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			yy_n_chars = yy_current_buffer->yy_n_chars;
			yy_current_buffer->yy_input_file = yyin;
			yy_current_buffer->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( yy_c_buf_p <= &yy_current_buffer->yy_ch_buf[yy_n_chars] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			yy_c_buf_p = yytext_ptr + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state();

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state );

			yy_bp = yytext_ptr + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++yy_c_buf_p;
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
				yy_cp = yy_c_buf_p;
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer() )
			{
			case EOB_ACT_END_OF_FILE:
				{
				yy_did_buffer_switch_on_eof = 0;

				if ( yywrap() )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * yytext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					yy_c_buf_p = yytext_ptr + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! yy_did_buffer_switch_on_eof )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				yy_c_buf_p =
					yytext_ptr + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state();

				yy_cp = yy_c_buf_p;
				yy_bp = yytext_ptr + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				yy_c_buf_p =
				&yy_current_buffer->yy_ch_buf[yy_n_chars];

				yy_current_state = yy_get_previous_state();

				yy_cp = yy_c_buf_p;
				yy_bp = yytext_ptr + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
	} /* end of yylex */


/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */

static int yy_get_next_buffer()
	{
	register char *dest = yy_current_buffer->yy_ch_buf;
	register char *source = yytext_ptr;
	register int number_to_move, i;
	int ret_val;

	if ( yy_c_buf_p > &yy_current_buffer->yy_ch_buf[yy_n_chars + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( yy_current_buffer->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( yy_c_buf_p - yytext_ptr - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) (yy_c_buf_p - yytext_ptr) - 1;

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( yy_current_buffer->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		yy_current_buffer->yy_n_chars = yy_n_chars = 0;

	else
		{
		int num_to_read =
			yy_current_buffer->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */
#ifdef YY_USES_REJECT
			YY_FATAL_ERROR(
"input buffer overflow, can't enlarge buffer because scanner uses REJECT" );
#else

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = yy_current_buffer;

			int yy_c_buf_p_offset =
				(int) (yy_c_buf_p - b->yy_ch_buf);

			if ( b->yy_is_our_buffer )
				{
				int new_size = b->yy_buf_size * 2;

				if ( new_size <= 0 )
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char *)
					/* Include room in for 2 EOB chars. */
					yy_flex_realloc( (void *) b->yy_ch_buf,
							 b->yy_buf_size + 2 );
				}
			else
				/* Can't grow it, we don't own it. */
				b->yy_ch_buf = 0;

			if ( ! b->yy_ch_buf )
				YY_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			yy_c_buf_p = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = yy_current_buffer->yy_buf_size -
						number_to_move - 1;
#endif
			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&yy_current_buffer->yy_ch_buf[number_to_move]),
			yy_n_chars, num_to_read );

		yy_current_buffer->yy_n_chars = yy_n_chars;
		}

	if ( yy_n_chars == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			yyrestart( yyin );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			yy_current_buffer->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	yy_n_chars += number_to_move;
	yy_current_buffer->yy_ch_buf[yy_n_chars] = YY_END_OF_BUFFER_CHAR;
	yy_current_buffer->yy_ch_buf[yy_n_chars + 1] = YY_END_OF_BUFFER_CHAR;

	yytext_ptr = &yy_current_buffer->yy_ch_buf[0];

	return ret_val;
	}


/* yy_get_previous_state - get the state just before the EOB char was reached */

static yy_state_type yy_get_previous_state()
	{
	register yy_state_type yy_current_state;
	register char *yy_cp;

	yy_current_state = yy_start;
	yy_state_ptr = yy_state_buf;
	*yy_state_ptr++ = yy_current_state;

	for ( yy_cp = yytext_ptr + YY_MORE_ADJ; yy_cp < yy_c_buf_p; ++yy_cp )
		{
		register YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
			{
			yy_current_state = (int) yy_def[yy_current_state];
			if ( yy_current_state >= 260 )
				yy_c = yy_meta[(unsigned int) yy_c];
			}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
		*yy_state_ptr++ = yy_current_state;
		}

	return yy_current_state;
	}


/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */

#ifdef YY_USE_PROTOS
static yy_state_type yy_try_NUL_trans( yy_state_type yy_current_state )
#else
static yy_state_type yy_try_NUL_trans( yy_current_state )
yy_state_type yy_current_state;
#endif
	{
	register int yy_is_jam;

	register YY_CHAR yy_c = 1;
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = (int) yy_def[yy_current_state];
		if ( yy_current_state >= 260 )
			yy_c = yy_meta[(unsigned int) yy_c];
		}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
	yy_is_jam = (yy_current_state == 259);
	if ( ! yy_is_jam )
		*yy_state_ptr++ = yy_current_state;

	return yy_is_jam ? 0 : yy_current_state;
	}


#ifndef YY_NO_UNPUT
#ifdef YY_USE_PROTOS
static void yyunput( int c, register char *yy_bp )
#else
static void yyunput( c, yy_bp )
int c;
register char *yy_bp;
#endif
	{
	register char *yy_cp = yy_c_buf_p;

	/* undo effects of setting up yytext */
	*yy_cp = yy_hold_char;

	if ( yy_cp < yy_current_buffer->yy_ch_buf + 2 )
		{ /* need to shift things up to make room */
		/* +2 for EOB chars. */
		register int number_to_move = yy_n_chars + 2;
		register char *dest = &yy_current_buffer->yy_ch_buf[
					yy_current_buffer->yy_buf_size + 2];
		register char *source =
				&yy_current_buffer->yy_ch_buf[number_to_move];

		while ( source > yy_current_buffer->yy_ch_buf )
			*--dest = *--source;

		yy_cp += (int) (dest - source);
		yy_bp += (int) (dest - source);
		yy_current_buffer->yy_n_chars =
			yy_n_chars = yy_current_buffer->yy_buf_size;

		if ( yy_cp < yy_current_buffer->yy_ch_buf + 2 )
			YY_FATAL_ERROR( "flex scanner push-back overflow" );
		}

	*--yy_cp = (char) c;


	yytext_ptr = yy_bp;
	yy_hold_char = *yy_cp;
	yy_c_buf_p = yy_cp;
	}
#endif	/* ifndef YY_NO_UNPUT */


#ifdef __cplusplus
static int yyinput()
#else
static int input()
#endif
	{
	int c;

	*yy_c_buf_p = yy_hold_char;

	if ( *yy_c_buf_p == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( yy_c_buf_p < &yy_current_buffer->yy_ch_buf[yy_n_chars] )
			/* This was really a NUL. */
			*yy_c_buf_p = '\0';

		else
			{ /* need more input */
			int offset = yy_c_buf_p - yytext_ptr;
			++yy_c_buf_p;

			switch ( yy_get_next_buffer() )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					yyrestart( yyin );

					/* fall through */

				case EOB_ACT_END_OF_FILE:
					{
					if ( yywrap() )
						return EOF;

					if ( ! yy_did_buffer_switch_on_eof )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput();
#else
					return input();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					yy_c_buf_p = yytext_ptr + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) yy_c_buf_p;	/* cast for 8-bit char's */
	*yy_c_buf_p = '\0';	/* preserve yytext */
	yy_hold_char = *++yy_c_buf_p;


	return c;
	}


#ifdef YY_USE_PROTOS
void yyrestart( FILE *input_file )
#else
void yyrestart( input_file )
FILE *input_file;
#endif
	{
	if ( ! yy_current_buffer )
		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE );

	yy_init_buffer( yy_current_buffer, input_file );
	yy_load_buffer_state();
	}


#ifdef YY_USE_PROTOS
void yy_switch_to_buffer( YY_BUFFER_STATE new_buffer )
#else
void yy_switch_to_buffer( new_buffer )
YY_BUFFER_STATE new_buffer;
#endif
	{
	if ( yy_current_buffer == new_buffer )
		return;

	if ( yy_current_buffer )
		{
		/* Flush out information for old buffer. */
		*yy_c_buf_p = yy_hold_char;
		yy_current_buffer->yy_buf_pos = yy_c_buf_p;
		yy_current_buffer->yy_n_chars = yy_n_chars;
		}

	yy_current_buffer = new_buffer;
	yy_load_buffer_state();

	/* We don't actually know whether we did this switch during
	 * EOF (yywrap()) processing, but the only time this flag
	 * is looked at is after yywrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	yy_did_buffer_switch_on_eof = 1;
	}


#ifdef YY_USE_PROTOS
void yy_load_buffer_state( void )
#else
void yy_load_buffer_state()
#endif
	{
	yy_n_chars = yy_current_buffer->yy_n_chars;
	yytext_ptr = yy_c_buf_p = yy_current_buffer->yy_buf_pos;
	yyin = yy_current_buffer->yy_input_file;
	yy_hold_char = *yy_c_buf_p;
	}


#ifdef YY_USE_PROTOS
YY_BUFFER_STATE yy_create_buffer( FILE *file, int size )
#else
YY_BUFFER_STATE yy_create_buffer( file, size )
FILE *file;
int size;
#endif
	{
	YY_BUFFER_STATE b;

	b = (YY_BUFFER_STATE) yy_flex_alloc( sizeof( struct yy_buffer_state ) );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) yy_flex_alloc( b->yy_buf_size + 2 );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_is_our_buffer = 1;

	yy_init_buffer( b, file );

	return b;
	}


#ifdef YY_USE_PROTOS
void yy_delete_buffer( YY_BUFFER_STATE b )
#else
void yy_delete_buffer( b )
YY_BUFFER_STATE b;
#endif
	{
	if ( ! b )
		return;

	if ( b == yy_current_buffer )
		yy_current_buffer = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		yy_flex_free( (void *) b->yy_ch_buf );

	yy_flex_free( (void *) b );
	}


#ifndef YY_ALWAYS_INTERACTIVE
#ifndef YY_NEVER_INTERACTIVE
extern int isatty YY_PROTO(( int ));
#endif
#endif

#ifdef YY_USE_PROTOS
void yy_init_buffer( YY_BUFFER_STATE b, FILE *file )
#else
void yy_init_buffer( b, file )
YY_BUFFER_STATE b;
FILE *file;
#endif


	{
	int oerrno = errno;

	yy_flush_buffer( b );

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

#if YY_ALWAYS_INTERACTIVE
	b->yy_is_interactive = 1;
#else
#if YY_NEVER_INTERACTIVE
	b->yy_is_interactive = 0;
#else
	b->yy_is_interactive = file ? (isatty( fileno(file) ) > 0) : 0;
#endif
#endif
	errno = oerrno;
	}


#ifdef YY_USE_PROTOS
void yy_flush_buffer( YY_BUFFER_STATE b )
#else
void yy_flush_buffer( b )
YY_BUFFER_STATE b;
#endif

	{
	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == yy_current_buffer )
		yy_load_buffer_state();
	}


#ifndef YY_NO_SCAN_BUFFER
#ifdef YY_USE_PROTOS
YY_BUFFER_STATE yy_scan_buffer( char *base, yy_size_t size )
#else
YY_BUFFER_STATE yy_scan_buffer( base, size )
char *base;
yy_size_t size;
#endif
	{
	YY_BUFFER_STATE b;

	if ( size < 2 ||
	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return 0;

	b = (YY_BUFFER_STATE) yy_flex_alloc( sizeof( struct yy_buffer_state ) );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_buffer()" );

	b->yy_buf_size = size - 2;	/* "- 2" to take care of EOB's */
	b->yy_buf_pos = b->yy_ch_buf = base;
	b->yy_is_our_buffer = 0;
	b->yy_input_file = 0;
	b->yy_n_chars = b->yy_buf_size;
	b->yy_is_interactive = 0;
	b->yy_at_bol = 1;
	b->yy_fill_buffer = 0;
	b->yy_buffer_status = YY_BUFFER_NEW;

	yy_switch_to_buffer( b );

	return b;
	}
#endif


#ifndef YY_NO_SCAN_STRING
#ifdef YY_USE_PROTOS
YY_BUFFER_STATE yy_scan_string( yyconst char *yy_str )
#else
YY_BUFFER_STATE yy_scan_string( yy_str )
yyconst char *yy_str;
#endif
	{
	int len;
	for ( len = 0; yy_str[len]; ++len )
		;

	return yy_scan_bytes( yy_str, len );
	}
#endif


#ifndef YY_NO_SCAN_BYTES
#ifdef YY_USE_PROTOS
YY_BUFFER_STATE yy_scan_bytes( yyconst char *bytes, int len )
#else
YY_BUFFER_STATE yy_scan_bytes( bytes, len )
yyconst char *bytes;
int len;
#endif
	{
	YY_BUFFER_STATE b;
	char *buf;
	yy_size_t n;
	int i;

	/* Get memory for full buffer, including space for trailing EOB's. */
	n = len + 2;
	buf = (char *) yy_flex_alloc( n );
	if ( ! buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_bytes()" );

	for ( i = 0; i < len; ++i )
		buf[i] = bytes[i];

	buf[len] = buf[len+1] = YY_END_OF_BUFFER_CHAR;

	b = yy_scan_buffer( buf, n );
	if ( ! b )
		YY_FATAL_ERROR( "bad buffer in yy_scan_bytes()" );

	/* It's okay to grow etc. this buffer, and we should throw it
	 * away when we're done.
	 */
	b->yy_is_our_buffer = 1;

	return b;
	}
#endif


#ifndef YY_NO_PUSH_STATE
#ifdef YY_USE_PROTOS
static void yy_push_state( int new_state )
#else
static void yy_push_state( new_state )
int new_state;
#endif
	{
	if ( yy_start_stack_ptr >= yy_start_stack_depth )
		{
		yy_size_t new_size;

		yy_start_stack_depth += YY_START_STACK_INCR;
		new_size = yy_start_stack_depth * sizeof( int );

		if ( ! yy_start_stack )
			yy_start_stack = (int *) yy_flex_alloc( new_size );

		else
			yy_start_stack = (int *) yy_flex_realloc(
					(void *) yy_start_stack, new_size );

		if ( ! yy_start_stack )
			YY_FATAL_ERROR(
			"out of memory expanding start-condition stack" );
		}

	yy_start_stack[yy_start_stack_ptr++] = YY_START;

	BEGIN(new_state);
	}
#endif


#ifndef YY_NO_POP_STATE
static void yy_pop_state()
	{
	if ( --yy_start_stack_ptr < 0 )
		YY_FATAL_ERROR( "start-condition stack underflow" );

	BEGIN(yy_start_stack[yy_start_stack_ptr]);
	}
#endif


#ifndef YY_NO_TOP_STATE
static int yy_top_state()
	{
	return yy_start_stack[yy_start_stack_ptr - 1];
	}
#endif

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

#ifdef YY_USE_PROTOS
static void yy_fatal_error( yyconst char msg[] )
#else
static void yy_fatal_error( msg )
char msg[];
#endif
	{
	(void) fprintf( stderr, "%s\n", msg );
	exit( YY_EXIT_FAILURE );
	}



/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
		yytext[yyleng] = yy_hold_char; \
		yy_c_buf_p = yytext + n; \
		yy_hold_char = *yy_c_buf_p; \
		*yy_c_buf_p = '\0'; \
		yyleng = n; \
		} \
	while ( 0 )


/* Internal utility routines. */

#ifndef yytext_ptr
#ifdef YY_USE_PROTOS
static void yy_flex_strncpy( char *s1, yyconst char *s2, int n )
#else
static void yy_flex_strncpy( s1, s2, n )
char *s1;
yyconst char *s2;
int n;
#endif
	{
	register int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
	}
#endif

#ifdef YY_NEED_STRLEN
#ifdef YY_USE_PROTOS
static int yy_flex_strlen( yyconst char *s )
#else
static int yy_flex_strlen( s )
yyconst char *s;
#endif
	{
	register int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
	}
#endif


#ifdef YY_USE_PROTOS
static void *yy_flex_alloc( yy_size_t size )
#else
static void *yy_flex_alloc( size )
yy_size_t size;
#endif
	{
	return (void *) malloc( size );
	}

#ifdef YY_USE_PROTOS
static void *yy_flex_realloc( void *ptr, yy_size_t size )
#else
static void *yy_flex_realloc( ptr, size )
void *ptr;
yy_size_t size;
#endif
	{
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return (void *) realloc( (char *) ptr, size );
	}

#ifdef YY_USE_PROTOS
static void yy_flex_free( void *ptr )
#else
static void yy_flex_free( ptr )
void *ptr;
#endif
	{
	free( ptr );
	}

#if YY_MAIN
int main()
	{
	yylex();
	return 0;
	}
#endif
#line 254 "control_lex.l"

/*"*/

int yywrap(void) 
{
	return 1;
}
	
void yyerror(char *s)
{
     int i;
	
	if(loop_record== -1)	{
		print_scan_err("File %s, line %d: %s\n",fname_list[list_ptr],lineno,s);
		loop_record= -2;
	}
	else if(loop_record>=0)	{
		print_scan_err("File %s, line %d: %s\n%s\n",fname_list[list_ptr],lineno,s,linebuf);
		if(scan_error_n<=max_scan_errors && linebuf[0]) {
			for(i=1;i<tokenpos;i++) (void)putc('-',stderr);
			(void)fputs("^\n",stderr);
		}
	}
	scan_error|=SCAN_ERR;
}

void yyerror1(char *s)
{
	if(loop_record== -1)	{
		print_scan_err("File %s, line %d: %s\n",fname_list[list_ptr],lineno1,s);
		loop_record= -2;
	} else if(loop_record>=0) print_scan_err("File %s, line %d: %s\n%s\n",fname_list[list_ptr],lineno1,s,linebuf1);
	scan_error|=SCAN_ERR;
}

void include_control_file(char *fname)
{
	FILE *fptr;
	YY_BUFFER_STATE ystate;
	int i,j;
	struct stat st1,st2;
	  
	if(fname) {
		if(!fname[0]) yyerror1("Null filename from INCLUDE command\n");
		if(stat(fname,&st1)) {
			(void)fprintf(stderr,"File: %s\n",fname);	
			yyerror1("Include file could not be stat()'d\n");
			perror(0);
			exit(EXIT_FAILURE);
		}
		for(i=0;i<=list_ptr;i++) {
			if(stat(fname_list[i],&st2)) {
				(void)fprintf(stderr,"File: %s\n",fname_list[i]);	
				yyerror1("Include file could not be stat()'d\n");
				perror(0);
				exit(EXIT_FAILURE);
			}
			if(st1.st_ino==st2.st_ino && st1.st_dev==st2.st_dev) {
				for(j=0;j<=list_ptr;j++) {
					if(j==i) (void)fprintf(stderr,"*%s* -> ",fname_list[j]);
					else (void)fprintf(stderr,"%s -> ",fname_list[j]);
				}
				(void)fprintf(stderr,"%s\n",fname);
				yyerror1("Recursive include files!\n");
				exit(EXIT_FAILURE);
			}
		}
		if(list_ptr<MAX_INCLUDE) {
			if(!(fptr=fopen(fname,"r"))) {
				yyerror1("Include file could not be opened");
				perror(0);
				exit(EXIT_FAILURE);
			}
			bufstate_list[list_ptr]=YY_CURRENT_BUFFER;
			ln_list[list_ptr]=lineno;
			ln1_list[list_ptr]=lineno1;
			lineno=lineno1=1;
			linebuf[0]=linebuf1[0]=0;
			fname_list[++list_ptr]=fname;
			ystate=yy_create_buffer(fptr,YY_BUF_SIZE);
			yy_switch_to_buffer(ystate);
		} else yyerror("Too many nested includes\n");
	}
}
  
static void append_to_sbuf(int *sptr,char c)
{
	if(*sptr>=MAX_STRING) print_scan_err("Line %d: Maximum string size exceeded",lineno);
	stringbuf[(*sptr)++]=c;
}

#ifdef FUNC_NAME
#undef FUNC_NAME
#endif
#define FUNC_NAME "get_string"
static char *get_string(char *s,int size)
{
	char *s1;
	if(!(s1=malloc(size))) ABT_FUNC(MMsg);
	(void)memcpy(s1,s,size);
	return s1;
}

#ifdef FUNC_NAME
#undef FUNC_NAME
#endif
#define FUNC_NAME "yylex"
int yylex(void)
{
	int tok,i;
	
	if(loop_record==1) {
		tok=yy_orig_lex();
		if(!loop_stack) {
			if(!(loop_stack=malloc(sizeof(struct token_store)*loop_stack_size))) ABT_FUNC(MMsg);
			loop_main_ptr=0;
		} else if(loop_main_ptr==loop_stack_size)	{
			loop_stack_size*=2;
			if(!(loop_stack=realloc(loop_stack,sizeof(struct token_store)*loop_stack_size))) ABT_FUNC(MMsg);
		}
		loop_stack[loop_main_ptr].line=lineno;
		loop_stack[loop_main_ptr].line1=lineno1;
		loop_stack[loop_main_ptr].yylval=yylval;
		if(tok==STRING) yylval.string=copy_string(yylval.string);
		loop_stack[loop_main_ptr++].token=tok;
		return tok;	   
	} else if(loop_record<0) {
		if(in_loopclause== -1) {
			in_loopclause= -2;
			return LOOP_CLAUSE_START;
		}
		yylval=loop_stack[loop_main_ptr].yylval;
		lineno=loop_stack[loop_main_ptr].line;
		lineno1=loop_stack[loop_main_ptr].line1;
		tok=loop_stack[loop_main_ptr++].token;
		if(tok==STRING) yylval.string=copy_string(yylval.string);
		if(in_loopclause) {
			if(tok==',' && loop_stack[loop_main_ptr].token==BREAK) {
				loop_clause_element->arg.value+=loop_clause_step;
				if(loop_clause_element->arg.value==loop_clause_end) i=0;
				else {
					i=(loop_clause_element->arg.value>loop_clause_end);
					if(loop_clause_step<0) i=1-i;
				}
				if(i) {
					loop_record=loop_stat[--loop_level];
					if(!loop_record) loop_main_ptr=loop_level?loop_ptr[loop_level-1]:0;
					else loop_main_ptr=loop_clause_ptr;
					in_loopclause=0;
					return LOOP_CLAUSE_END;
				} else loop_main_ptr=loop_ptr[loop_level-1];
			}
		}
		return tok;
	}
	/* Dummy call to shut up compiler warnings about yy_flex_realloc() not being used */
	if(0) (void)yy_flex_realloc(0,0);
	return yy_orig_lex();
}

void yy_cleanup(void)
{
	yy_delete_buffer(yy_current_buffer);
	if(loop_stack) free(loop_stack);
}

#ifdef FUNC_NAME
#undef FUNC_NAME
#endif
#define FUNC_NAME "process_env_var"
static void process_env_var(char *ptr)
{
	int i=0,j,k,size=512,brack;
	char *s,old,*stringptr;
	
	if(!(stringptr=malloc(size))) ABT_FUNC(MMsg);
	for(;;) {
		while(*ptr && *ptr!='$') {
			if(i>=size) {
				size+=size;
				if(!(stringptr=realloc(stringptr,size))) ABT_FUNC(MMsg);
			}
			stringptr[i++] = *(ptr++);
		}
		if(!(*ptr)) break;
		ptr++;
		j=0;
		brack=0;
		if(*ptr=='(') {
			ptr++;
			while(ptr[j] && ptr[j]!=')') j++;
			if(ptr[j]==')') brack=1;
		} else {
			while(isalnum((int)ptr[j]) || ptr[j]=='_') j++;
		}
		old=ptr[j];
		ptr[j]=0;
		if((s=getenv(ptr))) {
			if((k=strlen(s)))	{
				if(k+i>=size) {
					while(k+i>size) size+=size;
					if(!(stringptr=realloc(stringptr,size))) ABT_FUNC(MMsg);
				}
				(void)memcpy(stringptr+i,s,k);
				i+=k;
			}
		}
		ptr[j]=old;
		ptr+=j+brack;
	}
	while(i) unput(stringptr[--i]);
	free(stringptr);
}
